Description

I suggest a feature to export a version as text. One of the uses of the text is a changelog.

You will be able to get the text by clicking "Also available in: TXT" link placed in the bottom right of the version page.

If you export https://www.redmine.org/versions/5 as text, you will get the following output:

# Changelog

## 0.7.3

2008-07-06

Security+Bug fix release

* Defect #52: bulgarian language issue

* Defect #1426: User model does not allow person's first name to contain a dot '.'

* Feature #1506: Add title length note and error info when creating project or creating news

* Patch #1218: Patch for relative links to icon images in 'public/help/wiki_syntax.html'

* Patch #1425: Entourage (and some old client) fails to correctly render notification styles

* Patch #1524: back_url redirects inappropriately when blank

* Patch #1527: Add Project Name to Cross-Project Atom Feed

Related issues:

Related to Redmine - Feature #1800: Changelog creator New 2008-08-19

Related to Redmine - Feature #7043: Give user ability to generate changelogs Closed 2010-12-04

Associated revisions

Revision 22179 - 2023-04-13 06:20 - Go MAEDA

Export a version as changelog text (#36679).

Patch by Mizuki ISHIKAWA.

Revision 22184 - 2023-04-14 02:56 - Go MAEDA

Add a test for VersionsTextHelper (#36679).

Patch by Mizuki ISHIKAWA.

Revision 22196 - 2023-04-16 07:58 - Go MAEDA

Fix random test failure of VersionsTextHelperTest#test_version_to_text (#36679).

History

#1 - 2022-02-21 14:21 - Go MAEDA

- Related to Feature #1800: Changelog creator added

#2 - 2022-02-22 00:28 - Mizuki ISHIKAWA

+1
#3 - 2022-02-22 00:35 - Go MAEDA

- Related to Feature #7043: Give user ability to generate changelogs added

#4 - 2022-08-26 09:41 - Mizuki ISHIKAWA

- File screenshot_2022-08-26_16_38_29.png added

- File feature-36679.patch added

I have attached a patch to add this functionality.

 

#5 - 2022-09-07 15:44 - Go MAEDA

- File feature-36679-v2.patch added

- Target version set to Candidate for next major release

I made the following changes to the patch:

Add "*" at the beginning of each issue line

Fix the problem that the last issue line does not have trailing "\n"

#6 - 2022-09-17 10:50 - Go MAEDA

- File feature-36679-v3.patch added

I updated the patches to use the version name instead of the id when exporting to a file.

Suppose that the id of the version is 2 and the name is "1.0". In this case, the filename of the exported text will be "version-2.txt". I think it is very

confusing that the file name for exporting version "1.0" is "version-2.txt".

The new patch exports version "1.0" as "1.0.txt". This behavior is consistent with #16207.

#7 - 2022-09-18 06:00 - Mischa The Evil

Here are my thoughts based on feature-36679-v3.patch in case it is decided to add this to the Redmine core:

for clarity and consistency a colon should be added between the issue id and the subject (i.e. "* #{issue.tracker.name} ##{issue.id}: #{issue.

subject}\n");

for consistency (with e.g. wiki pages) the link-text should be changed from "Text" to "TXT";

on a more general note: I don't think that the version_details_to_text method belongs in the Version model. I think it would be better to have it as

a helper or as a method inside a dedicated 'export' module under source:/trunk/lib/redmine/export (this would also remove the need to include

Redmine::I18n into the Version model).

#8 - 2023-04-06 09:30 - Mizuki ISHIKAWA

- File feature-36679-v4.patch added

Mischa The Evil wrote in #note-7:

Here are my thoughts based on feature-36679-v3.patch in case it is decided to add this to the Redmine core:

for clarity and consistency a colon should be added between the issue id and the subject (i.e. "* #{issue.tracker.name} ##{issue.id}: #{issue.

subject}\n");

for consistency (with e.g. wiki pages) the link-text should be changed from "Text" to "TXT";

on a more general note: I don't think that the version_details_to_text method belongs in the Version model. I think it would be better to have

it as a helper or as a method inside a dedicated 'export' module under source:/trunk/lib/redmine/export (this would also remove the need to

include Redmine::I18n into the Version model).
 Thank you for your feedback.

I have updated the patch based on your feedback.

#9 - 2023-04-09 06:43 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

Setting the target version to 5.1.0.

#10 - 2023-04-13 06:21 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22179. Thank you.

Files

screenshot_2022-08-26_16_38_29.png 95.5 KB 2022-08-26 Mizuki ISHIKAWA

feature-36679.patch 3.43 KB 2022-08-26 Mizuki ISHIKAWA

feature-36679-v2.patch 3.53 KB 2022-09-07 Go MAEDA

feature-36679-v3.patch 3.52 KB 2022-09-17 Go MAEDA

feature-36679-v4.patch 5.89 KB 2023-04-06 Mizuki ISHIKAWA
